#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>


void *func1(void *arg) {
        static int exit_code = 0;
        printf("Thread 1\n");
        return &exit_code;
}

void *func2(void *arg) {
        static int exit_code = 4;
        printf("Thread 2\n");
        pthread_exit((void *)&exit_code);
}

int main(int argc, char *argv[]) {
        pthread_t thread1, thread2;
        pthread_create(&thread1, NULL, func1, NULL);
        pthread_create(&thread2, NULL, func2, NULL);

        int *status1, *status2;

        pthread_join(thread1, (void **)&status1);
        pthread_join(thread2, (void **)&status2);

        printf("Status1: %d\n", *status1);
        printf("Status2: %d\n", *status2);
        return EXIT_SUCCESS;
}

