#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>

void* myThread(void* arg) {
    // Dsactive l'annulation pour ce thread
    pthread_setcancelstate(PTHREAD_CANCEL_DISABLE, NULL);

    printf("Thread en cours d'excution...\n");

    // Ractive l'annulation
    pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, NULL);

    // Attend l'annulation (point d'annulation)
    while (1) {
        // Boucle infinie pour simuler un travail
        Sleep(1); // Ajout d'une pause pour viter une boucle CPU intensive
    }

    return NULL;
}

int main() {
    pthread_t tid;
    pthread_create(&tid, NULL, myThread, NULL);

    // Attente de l'annulation du thread
    Sleep(3); // Attente de 3 secondes pour illustrer l'annulation
    pthread_cancel(tid);
    pthread_join(tid, NULL);

    printf("Thread annul avec succs.\n");

    return 0;
}
