#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include "psleep.h"


 void *func(void *param) {

    pthread_setcancelstate(PTHREAD_CANCEL_DISABLE,NULL);

	//int static return_code = 77;
	sleep(5);
	pthread_setcancelstate(PTHREAD_CANCEL_ENABLE,NULL);
	pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS,NULL);
	sleep(5);
	printf("thread finished\n");
	//pthread_exit(&return_code);
}

void error(char *msg) {
	printf("%s\n", msg);
	exit(EXIT_FAILURE);
}

int main() {
	pthread_t th;
	int *v;


	if (pthread_create(&th, NULL, func, NULL) != 0) error("pthread_create FAILED");
	sleep(2);

	pthread_cancel(th);
    //sleep(4);


	if (pthread_join(th, (void **)&v) != 0) error("pthread_join FAILED\n");

	if (v == PTHREAD_CANCELED) printf("thread canceled\n");
	else printf("thread return code %d\n", *v);


	return EXIT_SUCCESS;

}


